// services/network/public/mojom/fetch_api.mojom-shared.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_NETWORK_PUBLIC_MOJOM_FETCH_API_MOJOM_SHARED_H_
#define SERVICES_NETWORK_PUBLIC_MOJOM_FETCH_API_MOJOM_SHARED_H_

#include <stdint.h>

#include <functional>
#include <ostream>
#include <type_traits>
#include <utility>

#include "base/compiler_specific.h"
#include "base/containers/flat_map.h"
#include "mojo/public/cpp/bindings/array_data_view.h"
#include "mojo/public/cpp/bindings/enum_traits.h"
#include "mojo/public/cpp/bindings/interface_data_view.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/map_data_view.h"
#include "mojo/public/cpp/bindings/string_data_view.h"
#include "services/network/public/mojom/fetch_api.mojom-shared-internal.h"







namespace network {
namespace mojom {


}  // namespace mojom
}  // namespace network

namespace mojo {
namespace internal {

}  // namespace internal
}  // namespace mojo


namespace network {
namespace mojom {


enum class RequestMode : int32_t {
  
  kSameOrigin = 0,
  
  kNoCors = 1,
  
  kCors = 2,
  
  kCorsWithForcedPreflight = 3,
  
  kNavigate = 4,
  kMinValue = 0,
  kMaxValue = 4,
};

 std::ostream& operator<<(std::ostream& os, RequestMode value);
inline bool IsKnownEnumValue(RequestMode value) {
  return internal::RequestMode_Data::IsKnownValue(
      static_cast<int32_t>(value));
}


enum class RequestDestination : int32_t {
  
  kEmpty = 0,
  
  kAudio = 1,
  
  kAudioWorklet = 2,
  
  kDocument = 3,
  
  kEmbed = 4,
  
  kFont = 5,
  
  kFrame = 6,
  
  kIframe = 7,
  
  kImage = 8,
  
  kManifest = 9,
  
  kObject = 10,
  
  kPaintWorklet = 11,
  
  kReport = 12,
  
  kScript = 13,
  
  kServiceWorker = 14,
  
  kSharedWorker = 15,
  
  kStyle = 16,
  
  kTrack = 17,
  
  kVideo = 18,
  
  kWorker = 19,
  
  kXslt = 20,
  kMinValue = 0,
  kMaxValue = 20,
};

 std::ostream& operator<<(std::ostream& os, RequestDestination value);
inline bool IsKnownEnumValue(RequestDestination value) {
  return internal::RequestDestination_Data::IsKnownValue(
      static_cast<int32_t>(value));
}


enum class RedirectMode : int32_t {
  
  kFollow = 0,
  
  kError = 1,
  
  kManual = 2,
  kMinValue = 0,
  kMaxValue = 2,
};

 std::ostream& operator<<(std::ostream& os, RedirectMode value);
inline bool IsKnownEnumValue(RedirectMode value) {
  return internal::RedirectMode_Data::IsKnownValue(
      static_cast<int32_t>(value));
}


enum class CredentialsMode : int32_t {
  
  kOmit = 0,
  
  kSameOrigin = 1,
  
  kInclude = 2,
  
  kOmitBug_775438_Workaround = 3,
  kMinValue = 0,
  kMaxValue = 3,
};

 std::ostream& operator<<(std::ostream& os, CredentialsMode value);
inline bool IsKnownEnumValue(CredentialsMode value) {
  return internal::CredentialsMode_Data::IsKnownValue(
      static_cast<int32_t>(value));
}


enum class FetchResponseType : int32_t {
  
  kBasic = 0,
  
  kCors = 1,
  
  kDefault = 2,
  
  kError = 3,
  
  kOpaque = 4,
  
  kOpaqueRedirect = 5,
  kMinValue = 0,
  kMaxValue = 5,
};

 std::ostream& operator<<(std::ostream& os, FetchResponseType value);
inline bool IsKnownEnumValue(FetchResponseType value) {
  return internal::FetchResponseType_Data::IsKnownValue(
      static_cast<int32_t>(value));
}


enum class FetchResponseSource : int32_t {
  
  kUnspecified = 0,
  
  kNetwork = 1,
  
  kHttpCache = 2,
  
  kCacheStorage = 3,
  kMinValue = 0,
  kMaxValue = 3,
};

 std::ostream& operator<<(std::ostream& os, FetchResponseSource value);
inline bool IsKnownEnumValue(FetchResponseSource value) {
  return internal::FetchResponseSource_Data::IsKnownValue(
      static_cast<int32_t>(value));
}


}  // namespace mojom
}  // namespace network

namespace std {

template <>
struct hash<::network::mojom::RequestMode>
    : public mojo::internal::EnumHashImpl<::network::mojom::RequestMode> {};

template <>
struct hash<::network::mojom::RequestDestination>
    : public mojo::internal::EnumHashImpl<::network::mojom::RequestDestination> {};

template <>
struct hash<::network::mojom::RedirectMode>
    : public mojo::internal::EnumHashImpl<::network::mojom::RedirectMode> {};

template <>
struct hash<::network::mojom::CredentialsMode>
    : public mojo::internal::EnumHashImpl<::network::mojom::CredentialsMode> {};

template <>
struct hash<::network::mojom::FetchResponseType>
    : public mojo::internal::EnumHashImpl<::network::mojom::FetchResponseType> {};

template <>
struct hash<::network::mojom::FetchResponseSource>
    : public mojo::internal::EnumHashImpl<::network::mojom::FetchResponseSource> {};

}  // namespace std

namespace mojo {


template <>
struct EnumTraits<::network::mojom::RequestMode, ::network::mojom::RequestMode> {
  static ::network::mojom::RequestMode ToMojom(::network::mojom::RequestMode input) { return input; }
  static bool FromMojom(::network::mojom::RequestMode input, ::network::mojom::RequestMode* output) {
    *output = input;
    return true;
  }
};

namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::network::mojom::RequestMode, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = EnumTraits<::network::mojom::RequestMode, UserType>;

  static void Serialize(UserType input, int32_t* output) {
    *output = static_cast<int32_t>(Traits::ToMojom(input));
  }

  static bool Deserialize(int32_t input, UserType* output) {
    return Traits::FromMojom(static_cast<::network::mojom::RequestMode>(input), output);
  }
};

}  // namespace internal


template <>
struct EnumTraits<::network::mojom::RequestDestination, ::network::mojom::RequestDestination> {
  static ::network::mojom::RequestDestination ToMojom(::network::mojom::RequestDestination input) { return input; }
  static bool FromMojom(::network::mojom::RequestDestination input, ::network::mojom::RequestDestination* output) {
    *output = input;
    return true;
  }
};

namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::network::mojom::RequestDestination, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = EnumTraits<::network::mojom::RequestDestination, UserType>;

  static void Serialize(UserType input, int32_t* output) {
    *output = static_cast<int32_t>(Traits::ToMojom(input));
  }

  static bool Deserialize(int32_t input, UserType* output) {
    return Traits::FromMojom(static_cast<::network::mojom::RequestDestination>(input), output);
  }
};

}  // namespace internal


template <>
struct EnumTraits<::network::mojom::RedirectMode, ::network::mojom::RedirectMode> {
  static ::network::mojom::RedirectMode ToMojom(::network::mojom::RedirectMode input) { return input; }
  static bool FromMojom(::network::mojom::RedirectMode input, ::network::mojom::RedirectMode* output) {
    *output = input;
    return true;
  }
};

namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::network::mojom::RedirectMode, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = EnumTraits<::network::mojom::RedirectMode, UserType>;

  static void Serialize(UserType input, int32_t* output) {
    *output = static_cast<int32_t>(Traits::ToMojom(input));
  }

  static bool Deserialize(int32_t input, UserType* output) {
    return Traits::FromMojom(static_cast<::network::mojom::RedirectMode>(input), output);
  }
};

}  // namespace internal


template <>
struct EnumTraits<::network::mojom::CredentialsMode, ::network::mojom::CredentialsMode> {
  static ::network::mojom::CredentialsMode ToMojom(::network::mojom::CredentialsMode input) { return input; }
  static bool FromMojom(::network::mojom::CredentialsMode input, ::network::mojom::CredentialsMode* output) {
    *output = input;
    return true;
  }
};

namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::network::mojom::CredentialsMode, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = EnumTraits<::network::mojom::CredentialsMode, UserType>;

  static void Serialize(UserType input, int32_t* output) {
    *output = static_cast<int32_t>(Traits::ToMojom(input));
  }

  static bool Deserialize(int32_t input, UserType* output) {
    return Traits::FromMojom(static_cast<::network::mojom::CredentialsMode>(input), output);
  }
};

}  // namespace internal


template <>
struct EnumTraits<::network::mojom::FetchResponseType, ::network::mojom::FetchResponseType> {
  static ::network::mojom::FetchResponseType ToMojom(::network::mojom::FetchResponseType input) { return input; }
  static bool FromMojom(::network::mojom::FetchResponseType input, ::network::mojom::FetchResponseType* output) {
    *output = input;
    return true;
  }
};

namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::network::mojom::FetchResponseType, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = EnumTraits<::network::mojom::FetchResponseType, UserType>;

  static void Serialize(UserType input, int32_t* output) {
    *output = static_cast<int32_t>(Traits::ToMojom(input));
  }

  static bool Deserialize(int32_t input, UserType* output) {
    return Traits::FromMojom(static_cast<::network::mojom::FetchResponseType>(input), output);
  }
};

}  // namespace internal


template <>
struct EnumTraits<::network::mojom::FetchResponseSource, ::network::mojom::FetchResponseSource> {
  static ::network::mojom::FetchResponseSource ToMojom(::network::mojom::FetchResponseSource input) { return input; }
  static bool FromMojom(::network::mojom::FetchResponseSource input, ::network::mojom::FetchResponseSource* output) {
    *output = input;
    return true;
  }
};

namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::network::mojom::FetchResponseSource, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = EnumTraits<::network::mojom::FetchResponseSource, UserType>;

  static void Serialize(UserType input, int32_t* output) {
    *output = static_cast<int32_t>(Traits::ToMojom(input));
  }

  static bool Deserialize(int32_t input, UserType* output) {
    return Traits::FromMojom(static_cast<::network::mojom::FetchResponseSource>(input), output);
  }
};

}  // namespace internal

}  // namespace mojo


namespace network {
namespace mojom {


}  // namespace mojom
}  // namespace network

#endif  // SERVICES_NETWORK_PUBLIC_MOJOM_FETCH_API_MOJOM_SHARED_H_